package com.zanxiang.game.back.serve.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zanxiang.erp.security.annotation.PreAuthorize;
import com.zanxiang.game.back.serve.pojo.dto.*;
import com.zanxiang.game.back.serve.pojo.vo.*;
import com.zanxiang.game.back.serve.service.*;
import com.zanxiang.module.util.pojo.ResultVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/game/back")
@Api("回传策略")
public class BackPolicyController {
    @Autowired
    private IGameBackPolicyService gameBackPolicyService;
    @Autowired
    private IGameTencentUserService tencentUserService;
    @Autowired
    private IGameTencentOrderService tencentOrderService;
    @Autowired
    private IGameOceanengineOrderLogService oceanengineOrderLogService;
    @Autowired
    private IGameOceanengineUserLogService oceanengineUserLogService;

//    @PreAuthorize(permissionKey = "gameBack:policy:create")
    @PostMapping("/policy/create")
    @ApiOperation(value = "创建回传策略")
    public ResultVO<Boolean> createPolicy(@RequestBody GameBackPolicyDTO dto) {
        return ResultVO.ok(gameBackPolicyService.createPolicy(dto));
    }

//    @PreAuthorize(permissionKey = "gameBack:policy:update")
    @PostMapping("/policy/update")
    @ApiOperation(value = "修改回传策略")
    public ResultVO<Boolean> updatePolicy(@RequestBody GameBackPolicyDTO dto) {
        return ResultVO.ok(gameBackPolicyService.updatePolicy(dto));
    }

//    @PreAuthorize(permissionKey = "gameBack:policy:delete")
    @PostMapping("/policy/delete/{ids}")
    @ApiOperation(value = "删除回传策略")
    public ResultVO<Boolean> deletePolicy(@PathVariable("ids") List<Long> ids) {
        return ResultVO.ok(gameBackPolicyService.deletePolicy(ids));
    }

//    @PreAuthorize(permissionKey = "gameBack:policy:list")
    @PostMapping("/policy/list")
    @ApiOperation(value = "回传策略列表")
    public ResultVO<IPage<GameBackPolicyVO>> policyList(@RequestBody GameBackPolicyListDTO dto) {
        return ResultVO.ok(gameBackPolicyService.policyList(dto));
    }

//    @PreAuthorize(permissionKey = "gameBack:tencent:orderLogs")
    @PostMapping("/tencent/orderLogs")
    @ApiOperation(value = "腾讯订单回传日志列表")
    public ResultVO<IPage<GameTencentOrderVO>> tencentOrderLogList(@RequestBody GameTencentOrderDTO dto) {
        return ResultVO.ok(tencentOrderService.tencentOrderLogList(dto));
    }

//    @PreAuthorize(permissionKey = "gameBack:tencent:orderReport")
    @PostMapping("/tencent/orderReport/{ids}")
    @ApiOperation(value = "腾讯订单手动上报")
    public ResultVO<Boolean> tencentOrderReport(@PathVariable("ids") List<Long> ids) {
        return ResultVO.ok(tencentOrderService.tencentOrderReport(ids));
    }

//    @PreAuthorize(permissionKey = "gameBack:tencent:userLogs")
    @PostMapping("/tencent/userLogs")
    @ApiOperation(value = "腾讯用户回传日志列表")
    public ResultVO<IPage<GameTencentUserVO>> tencentUserLogList(@RequestBody GameTencentUserDTO dto) {
        return ResultVO.ok(tencentUserService.tencentUserLogList(dto));
    }

//    @PreAuthorize(permissionKey = "gameBack:tencent:userReport")
    @PostMapping("/tencent/userReport/{ids}")
    @ApiOperation(value = "腾讯用户手动上报")
    public ResultVO<Boolean> tencentUserReport(@PathVariable("ids") List<Long> ids) {
        return ResultVO.ok(tencentUserService.tencentUserReport(ids));
    }

//    @PreAuthorize(permissionKey = "gameBack:oceanengine:orderLogs")
    @PostMapping("/oceanengine/orderLogs")
    @ApiOperation(value = "头条订单回传日志列表")
    public ResultVO<IPage<GameOceanengineOrderLogVO>> oceanengineOrderLogList(@RequestBody GameOceanengineOrderLogDTO dto) {
        return ResultVO.ok(oceanengineOrderLogService.oceanengineOrderLogList(dto));
    }

//    @PreAuthorize(permissionKey = "gameBack:oceanengine:orderReport")
    @PostMapping("/oceanengine/orderReport/{ids}")
    @ApiOperation(value = "头条订单手动上报")
    public ResultVO<Boolean> oceanengineOrderReport(@PathVariable("ids") List<Long> ids) {
        return ResultVO.ok(oceanengineOrderLogService.oceanengineOrderReport(ids));
    }

//    @PreAuthorize(permissionKey = "gameBack:oceanengine:userLogs")
    @PostMapping("/oceanengine/userLogs")
    @ApiOperation(value = "头条用户回传日志列表")
    public ResultVO<IPage<GameOceanengineUserLogVO>> oceanengineUserLogList(@RequestBody GameOceanengineUserLogDTO dto) {
        return ResultVO.ok(oceanengineUserLogService.oceanengineUserLogList(dto));
    }

//    @PreAuthorize(permissionKey = "gameBack:oceanengine:userReport")
    @PostMapping("/oceanengine/userReport/{ids}")
    @ApiOperation(value = "头条用户手动上报")
    public ResultVO<Boolean> oceanengineUserReport(@PathVariable("ids") List<Long> ids) {
        return ResultVO.ok(oceanengineUserLogService.oceanengineUserReport(ids));
    }
}
